import matplotlib.pyplot as plt
from fc_tools.colors import str2rgb
from fc_hypermesh.OrthMesh import OrthMesh
from fc_tools.graphics import DisplayFigures,SaveAllFigsAsFiles,set_axes_equal
#from OrthMesh import OrthMesh

def demo01():
  oTh=OrthMesh(3,5,type='orthotope',box=[[-1,1],[-1,1],[-1,1]])

  plt.ion()
  plt.figure(1)
  plt.clf()
  oTh.plotmesh(legend=True)
  set_axes_equal()

  plt.figure(2)
  plt.clf()
  oTh.plotmesh(m=2,legend=True,edgecolor=[0,0,0])
  set_axes_equal()
  plt.axis('off')

  plt.figure(3)
  plt.clf()
  oTh.plotmesh(m=2,facecolor=None,edgecolor=str2rgb('LightGray'))
  oTh.plotmesh(m=1,legend=True,linewidth=2)
  set_axes_equal()
  plt.axis('off')

  plt.figure(4)
  plt.clf()
  oTh.plotmesh(m=1,color='black')
  oTh.plotmesh(m=0,legend=True,s=55) # see matplotlib.pyplot.scatter options
  set_axes_equal()
  plt.axis('off')

  DisplayFigures(screen=1)
  
def demo02():
  oTh=OrthMesh(2,5,type='orthotope',box=[[-1,1],[-1,1],[-1,1]])

  plt.close('all')
  plt.ion()
  plt.figure(1)
  plt.clf()
  oTh.plotmesh(legend=True)

  plt.figure(2)
  plt.clf()
  oTh.plotmesh(m=1,legend=True,linewidth=3)


  plt.figure(3)
  plt.clf()
  oTh.plotmesh(m=1,color='black')
  oTh.plotmesh(m=0,legend=True,s=105) # see matplotlib.pyplot.scatter options
  DisplayFigures(screen=1)
  
def demo03():
  oTh=OrthMesh(3,[10,5,10],box=[[-1,1],[0,1],[0,2]])

  plt.close('all')
  plt.ion()
  plt.figure(1)
  plt.clf()
  oTh.plotmesh(legend=True,linewidth=0.5)
  set_axes_equal()

  plt.figure(2)
  plt.clf()
  oTh.plotmesh(m=2,legend=True,edgecolor=[0,0,0])
  set_axes_equal()

  plt.figure(3)
  plt.clf()
  oTh.plotmesh(m=2,edgecolor=[0,0,0],color='none')
  oTh.plotmesh(m=1,legend=True,linewidth=2,alpha=0.3)
  set_axes_equal()

  plt.figure(4)
  plt.clf()
  oTh.plotmesh(m=1,color='black',alpha=0.3)
  oTh.plotmesh(m=0,legend=True,s=55)
  set_axes_equal()
  plt.axis('off')

  DisplayFigures(screen=1)
  
def demo04():
  plt.close('all')
  plt.ion()
  
  oTh=OrthMesh(2,10,type='simplicial',box=[[-1,1],[0,1]])

  plt.figure(1)
  plt.clf()
  oTh.plotmesh(legend=True)
  set_axes_equal()

  plt.figure(2)
  plt.clf()
  oTh.plotmesh(m=1,legend=True,linewidth=3)
  plt.axis('off')
  set_axes_equal()

  plt.figure(3)
  plt.clf()
  oTh.plotmesh(m=1,color='black')
  oTh.plotmesh(m=0,legend=True,s=105) # see matplotlib.pyplot.scatter options
  plt.axis('off')
  set_axes_equal()

  DisplayFigures(screen=1)
  
def demo05():
  trans=lambda q: np.array([2*q[0],q[1]])
  oTh=OrthMesh(2,5,type='simplicial',mapping=trans)

  plt.close('all')
  plt.ion()
  plt.figure(1)
  plt.clf()
  oTh.plotmesh(legend=True)
  set_axes_equal()

  plt.figure(2)
  plt.clf()
  oTh.plotmesh(color='lightgray')
  oTh.plotmesh(m=1,legend=True,linewidth=3)
  plt.axis('equal')
  plt.axis('off')

  plt.figure(3)
  plt.clf()
  oTh.plotmesh(color='lightgray')
  oTh.plotmesh(m=1,color='black')
  oTh.plotmesh(m=0,legend=True,s=105) # see matplotmeshlib.pyplotmesh.scatter options
  plt.axis('equal')
  plt.axis('off')

  DisplayFigures(screen=1)  
  
def demo06():
  trans=lambda q: np.array([20*q[0],2*(2*q[1]-1+np.cos(2*np.pi*q[0]))])
  oTh=OrthMesh(2,[100,20],type='simplicial',mapping=trans)#box=[[-1,1],[-1,1],[-1,1]])

  plt.close('all')
  plt.ion()
  plt.figure(1)
  plt.clf()
  oTh.plotmesh(legend=True)
  plt.axis('equal')

  plt.figure(2)
  plt.clf()
  oTh.plotmesh(color='lightgray')
  oTh.plotmesh(m=1,legend=True,linewidth=3)
  plt.axis('equal')
  plt.axis('off')

  plt.figure(3)
  plt.clf()
  oTh.plotmesh(color='lightgray')
  oTh.plotmesh(m=1,color='black')
  oTh.plotmesh(m=0,legend=True,s=105) # see matplotlib.pyplot.scatter options
  plt.axis('equal')
  plt.axis('off')

  DisplayFigures(screen=1)
  
def demo07():
  N1=3;N2=25;N3=3
  d=3
  trans=lambda q: np.array([q[0]+np.sin(4*np.pi*q[1]), 10*q[1]-1, q[2]+np.cos(4*np.pi*q[1])])
  oTh=OrthMesh(3,[3,25,3],type='simplicial',mapping=trans)

  plt.close('all')
  plt.ion()
  plt.figure(1)
  plt.clf()
  oTh.plotmesh(legend=True)
  set_axes_equal()

  plt.figure(2)
  plt.clf()
  oTh.plotmesh(m=2,legend=True,edgecolor=[0,0,0])
  set_axes_equal()

  plt.figure(3)
  plt.clf()
  oTh.plotmesh(m=2,edgecolor='lightgray',facecolor=None,alpha=0.3)
  oTh.plotmesh(m=1,legend=True,linewidth=2)
  set_axes_equal()

  plt.figure(4)
  plt.clf()
  oTh.plotmesh(m=1,color='black')
  oTh.plotmesh(m=0,legend=True,s=55)
  set_axes_equal()

  DisplayFigures(screen=1)